# Pull Requests

Please ensure your pull requests meets the following criteria **before** submitting.

* I am not making any insignificant style changes like removing unused `using` statements.
* My change follows the same style as the rest of the code base.
* If my change is non-trivial I have already submitted a proposal by opening an issue and it was approved.
* My changes have unit tests that cover any new areas of code.

I appreciate contributions but my time is limited. If you send me a pull request that makes significant changes without discussing the change with me first I will likely reject your pull request. I do not have time to review large changes that may or may not benefit this library.

Thank you for reading this.
